module.exports = operations

// returns object containing CRUD operations on a collection
function operations(Query) {
  return {
    create (options, callback) {
      let query = new Query(options)

      query.save(err => {
        if (err) {
          return callback(err)
        }
        callback(null, options)
      })
    },
    read (querymethod, options, callback) {
      Query[querymethod](options, (err, returnValue) => {
        if (err) {
          return callback(err)
        }
        callback(null, returnValue)
      })
    },
    update (query, update, callback) {
      Query.update(query, update, (err, returnValue) => {
        if (err) {
          return callback(err)
        }
        callback(null, returnValue)
      })
    },
    delete (query, callback) {
      Query.remove(query, (err, returnValue) => {
        if (err) {
          return callback(err)
        }
        callback(null, returnValue)
      })
    }
  }
}
